Upload a File to Document note.file.add

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: note

Who can execute the method: a user with access to the Knowledge base module and "Edit" permissions for the document Knowledge base

The note.file.add method uploads a file to a document and returns a file object.

The method does not automatically insert the attachment into the document content. It only saves the file and links it to the document.

Method Parameters

Required parameters are marked with *

Name
type

Description

documentId*
integer

Identifier of the document to which the file should be attached.

The identifier can be obtained using the note.document.tree.list method

fileName*
string

File name with extension.

Allowed extensions: png, jpg, jpeg, gif, webp, svg, pdf, txt, md, csv, doc, docx, xls, xlsx, ppt, pptx, mp4, webm, mov

fileContent*
string

Binary file content in Base64 encoding.

The maximum file size depends on the main.max_file_size setting in Bitrix24. If it is not set, the 25 MiB (25 * 1024 * 1024 bytes) limit is used

Code Examples

How to Use Examples in Documentation

The new API call differs by adding the /api/ segment to the request URL:

https://{installation_address}/rest/api/{user_id}/{webhook_token}/note.file.add

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"documentId":77,"fileName":"diagram.png","fileContent":"iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII="}' \
        https://**put_your_bitrix24_address**/rest/api/**put_your_user_id_here**/**put_your_webhook_here**/note.file.add
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"documentId":77,"fileName":"diagram.png","fileContent":"iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII=","auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/api/note.file.add
        
import { Text } from '@bitrix24/b24jssdk'
        import type { B24Frame } from '@bitrix24/b24jssdk'
        
        declare const $b24: B24Frame
        
        type FileAddResult = {
          item: {
            id: number
            documentId: number
            name: string
            size: number
            mimeType: string
            assetType: string
            assetMarkdown: string
          }
        }
        
        try {
          const response = await $b24.actions.v3.call.make<FileAddResult>({
            method: 'note.file.add',
            params: {
              documentId: 77,
              fileName: 'diagram.png',
              fileContent: 'iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII=',
            },
            requestId: Text.getUuidRfc4122()
          })
        
          if (!response.isSuccess) {
            console.error(response.getErrorMessages().join('; '))
          } else {
            const result = response.getData()!.result
            console.info('File uploaded:', result.item.id, result.item.assetMarkdown)
          }
        } catch (error) {
          console.error(error)
        }
        
<script src="https://unpkg.com/@bitrix24/b24jssdk@1/dist/umd/index.min.js"></script>
        <script>
          async function addFile() {
            try {
              const $b24 = await B24Js.initializeB24Frame()
        
              const response = await $b24.actions.v3.call.make({
                method: 'note.file.add',
                params: {
                  documentId: 77,
                  fileName: 'diagram.png',
                  fileContent: 'iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII=',
                },
                requestId: B24Js.Text.getUuidRfc4122()
              })
        
              if (!response.isSuccess) {
                console.error(response.getErrorMessages().join('; '))
                return
              }
        
              const result = response.getData().result
              console.info('File uploaded:', result.item.id, result.item.assetMarkdown)
            } catch (error) {
              console.error(error)
            }
          }
        
          document.addEventListener('DOMContentLoaded', addFile)
        </script>
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

try {
            $response = $b24Service
                ->core
                ->call(
                    'note.file.add',
                    [
                        'documentId' => 77,
                        'fileName' => 'diagram.png',
                        'fileContent' => 'iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII=',
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error uploading file: ' . $e->getMessage();
        }
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

BX24.callMethod(
            'note.file.add',
            {
                documentId: 77,
                fileName: 'diagram.png',
                fileContent: 'iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII='
            },
            function(result){
                console.info(result.data());
                console.log(result);
            }
        );
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

require_once('crest.php');
        
        $result = CRest::call(
            'note.file.add',
            [
                'documentId' => 77,
                'fileName' => 'diagram.png',
                'fileContent' => 'iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII='
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP status: 200

{
            "result": {
                "item": {
                    "id": 5001,
                    "documentId": 77,
                    "name": "diagram.png",
                    "size": 6321,
                    "mimeType": "image/png",
                    "assetType": "image",
                    "assetMarkdown": "[[image fileId=5001]]"
                }
            },
            "time": {
                "start": 1780392000,
                "finish": 1780392000.284521,
                "duration": 0.28452086448669434,
                "processing": 0.2413930892944336,
                "date_start": "2026-06-16T12:20:00+03:00",
                "date_finish": "2026-06-16T12:20:00+03:00",
                "operating_reset_at": 1780392600,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
object

Object with the file upload result

item
object

Object of the uploaded file

id
integer

Identifier of the uploaded file

documentId
integer

Identifier of the document to which the file is attached

name
string

File name

size
integer

File size in bytes

mimeType
string

File MIME type

assetType
string

Attachment type for the Markdown block

assetMarkdown
string

Ready-to-use Markdown block for inserting the file into a document via note.document.update

time
time

Information about the request execution time

Error Handling

HTTP status: 400

{
            "error": {
                "code": "BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION",
                "message": "Error during request object validation",
                "validation": [
                    {
                        "message": "invalid base64 payload",
                        "field": "fileContent"
                    }
                ]
            }
        }
        

Name
type

Description

error.code
string

String error code. Use it to identify the type of exception

error.message
string

Text description of the error

error.validation
array

Array with error details. Present only in data validation errors BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

error.validation[].field
string

Name of the field where the validation error occurred

error.validation[].message
string

Description of the error related to the specified field

Possible Error Codes

Request Validation Errors

Error Code: BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

Field

Error description

How to Fix

documentId
fileName
fileContent

Required field #FIELD# is not specified

Add the specified field to the request body

documentId
fileName
fileContent

The field #FIELD# requires data type #TYPE# for this request

Ensure the provided value is of the correct type

fileContent

Incorrect Base64 content provided

Please ensure that fileContent contains a non-empty Base64 string without corrupted characters

fileContent

Failed to save the file

Retry the request later or check the correctness of the provided data

Error Code: NOTE_FILE_TOO_LARGE

Field

Error description

How to Fix

fileContent

File size exceeds the allowed value

Reduce the file size or change the main.max_file_size setting in Bitrix24

Error Code: NOTE_FILE_TYPE_NOT_ALLOWED

Field

Error description

How to Fix

fileName

File type is not supported

Use a file with an allowed extension

Access Errors

Error Code: BITRIX_REST_V3_EXCEPTION_ACCESSDENIEDEXCEPTION

Field

Error description

How to Fix

-

Access denied

The user does not have access to the Knowledge Base module or permissions to edit the document

Object Not Found Error

Error Code: BITRIX_REST_V3_EXCEPTION_ENTITYNOTFOUNDEXCEPTION

Field

Error description

How to Fix

documentId

Document not found

Please ensure that the document exists, is not archived, and is not in the trash

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning